/************************************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * This source may be used also with another licence, if the author 
 * and all other here named co-authors have agreed to this contract.
 * Especially a company can use a copy of this sources in its products without publishing.
 * The user should have a underwritten contract therefore.
 *
 * @author Hartmut Schorrig, Germany, Pinzberg, www.vishia.org
 *
 **copyright***************************************************************************************
 *
 * @content Definition of error numbers. 
 *
 * @author Hartmut Schorrig
 * @version sf-0.83
 * list of changes:
 * 2008-02-01: Hartmut creation 
 *
 ************************************************************************************************/

#ifndef __os_error_h__
#define __os_error_h__

//Funktion-Fehlercode
#define OS_OK                  0
#define OS_SYSTEM_ERROR      -100	// System Fehler.
#define OS_INVALID_PARAMETER -101	// Ein Parameter war ungltig.
#define OS_INVALID_STRING	   -102	// Ein String ist nicht innerhalb der vorgegebenen Gre.
#define OS_INVALID_HANDLE    -103	// Das Objekt-Handle ist ungltig.
//#define OS_INVALID_STATE     -104	// Der Objekt-Sustand ist ungltig fr diese Operation.
//#define OS_TEST_NOT_OK       -105	// Testbedingungen nicht erfllt.
#define OS_GOT_TIMEOUT       -106	// Der Aufruf wurde nach dem eingestellten Timeout abgebrochen.
//#define OS_QUEUE_EXIST       -107	// Die Message-Queue existiert bereits fr diesen Thread.
//#define OS_QUEUE_NOT_EXIST   -108	// Die Message-Queue dieses Thread existiert nicht.
#define OS_RESOURCE_BUSY     -109	// In diesem Objekt stehen noch Nachrichten, oder ein Thread wartet.
//#define OS_QUEUE_FULL        -110	// Die MessageQueue ist voll.
//#define OS_QUEUE_EMPTY       -111	// Die Message-Queue enthlt keine Nachricht
//#define OS_NAME_EXIST        -112	// Der Name existiert bereits.
#define OS_NAME_NOT_EXIST    -113	// Der angegebene Name existiert im System nicht.
//#define OS_MAILBOX_FULL      -114	// Die Anforderung berschreitet die eingetragene Grenze der Mailbox.
//#define OS_MAILBOX_EMPTY     -115	// Die Mailbox enthlt keine Nachricht (wenn timeOut = 0).
#define OS_INVALID_POINTER   -116	// Zeiger zu Resource ungltig.
#define OS_UNEXPECTED_CALL   -117	// Aufruf an dieser Stelle nicht erwartet/statthaft.
#define OS_UNKNOWN_ERROR     -200	// Undefinierte Fehlermeldung


/**All Warnings can be ignored by user. They mustn't be used in software algorithm.
 * In debug situations it is possible to evaluate it.
 */
typedef enum OS_ReturnCodes_t
{ OS_WARNING_NOTIFY_TooManyPosts =     10001
, OS_WARNING_NOTIFY_NothingIsWaiting = 10002
}OS_ReturnCodes;  

/**Stops the execution of the executable because no error handling is possible.
 * This routine should only called in normally safe, but unexpected situations
 * at system level. At user level the routine shouldn't called.
 */
void os_fatalError(const char* text, int value);



#endif // __os_error_h__
