/************************************************************************************************
 * Copyright/Copyleft:
 *
 * For this source the LGPL Lesser General Public License,
 * published by the Free Software Foundation is valid.
 * It means:
 * 1) You can use this source without any restriction for any desired purpose.
 * 2) You can redistribute copies of this source to everybody.
 * 3) Every user of this source, also the user of redistribute copies
 *    with or without payment, must accept this license for further using.
 * 4) But the LPGL ist not appropriate for a whole software product,
 *    if this source is only a part of them. It means, the user
 *    must publish this part of source,
 *    but don't need to publish the whole source of the own product.
 * 5) You can study and modify (improve) this source
 *    for own using or for redistribution, but you have to license the
 *    modified sources likewise under this LGPL Lesser General Public License.
 *    You mustn't delete this Copyright/Copyleft inscription in this source file.
 *
 * This source may be used also with another licence, if the author 
 * and all other here named co-authors have agreed to this contract.
 * Especially a company can use a copy of this sources in its products without publishing.
 * The user should have a underwritten contract therefore.
 *
 * @author Hartmut Schorrig, Germany, Pinzberg, www.vishia.org
 *
 **copyright***************************************************************************************
 *
 * @content This file contains the implementation of os_file.h for MS-Windows.
 * @author Hartmut Schorrig www.vishia.org
 * @version 0.94
 * list of changes:
 * 2009-06-01: JcHartmut creation
 *
 ****************************************************************************/
#include "OSAL/inc/os_file.h"





#include "sys/stat.h"
#include "string.h" //memset

int os_getFileDescription(OS_FileDescription* dst, int addPathLength, char const* filepath)
{
  
  struct stat statData;

  
  int ok = stat(filepath, &statData);

  if(ok == 0)
  { 
    dst->fileLength = statData.st_size;
    dst->flags = mExist_OS_FileDescription | mCanRead_OS_FileDescription; 

    { //st_mtime is the time of last changed, seconds after 1970 in UTC. MS-Visual studio: Its a long.
      int32 timeLastChanged = statData.st_mtime;
      setUTC_OS_TimeStamp(dst->timeChanged, timeLastChanged, 0);
    }
  }
  else
  { memset(dst, 0, sizeof(*dst));  //especially mExist_OS_FileDescription-bit is 0
  }
  return ok;

}