/**************************************************************************
 * This file is generated by Java2C
 **copyright***************************************************************
 *************************************************************************/
#ifndef __PosCtrl_PID_controller_h__
#define __PosCtrl_PID_controller_h__

#include "Jc/ObjectJc.h"

#include "Fwc/fw_Exception.h"   //basic concept
#include "PosCtrl/CtrlBase.h"  //interface


/*@CLASS_C PID_controller @@@@@@@@@@@@@@@@@@@@@@@@*/

typedef struct PID_controller_t
{ 
  union { ObjectJc object; CtrlBase_s CtrlBase;} base; 
  int32 intgVal;  /*The integral value of the controller. */
  int16 lastForDiff;  /*The last value to build the difference. */
  int16 kI;  /*The I amplification, unit per sample step*/
  int16 kP;  /*The P amplification*/
  int16 kD;  /*The D amplification*/
  int16_Y* x;  /*The reference to the input value. */
  int16_Y* yTEST;  /*The output value. */
} PID_controller_s;
  

typedef struct PID_controller_Y_t { ObjectArrayJc head; PID_controller_s data[50]; } PID_controller_Y;

extern struct ClassJc_t const reflection_PID_controller_s;
  



/**Default constructor. */
METHOD_C struct PID_controller_t* ctorO_PID_controller(ObjectJc* othis, ThCxt* _thCxt);

/**the step-method, called one-time per cycle-time to calculate the next value.*/
typedef int16 MT_calculate_PID_controller(PID_controller_s* ythis, int16 input, ThCxt* _thCxt);
/* J2C:Implementation of the method, used for an immediate non-dynamic call: */
METHOD_C int16 calculate_PID_controller_F(PID_controller_s* ythis, int16 input, ThCxt* _thCxt);
/* J2C:Call of the method at this class level, executes a dynamic call of the override-able method: */
METHOD_C int16 calculate_PID_controller(PID_controller_s* ythis, int16 input, ThCxt* _thCxt);

/**Sets the integral value to a predefined value.*/
typedef void MT_setIntg_PID_controller(PID_controller_s* ythis, int16 setValue, ThCxt* _thCxt);
/* J2C:Implementation of the method, used for an immediate non-dynamic call: */
METHOD_C void setIntg_PID_controller_F(PID_controller_s* ythis, int16 setValue, ThCxt* _thCxt);
/* J2C:Call of the method at this class level, executes a dynamic call of the override-able method: */
METHOD_C void setIntg_PID_controller(PID_controller_s* ythis, int16 setValue, ThCxt* _thCxt);

/**Gets the value of the internal integrator for displayment*/
typedef float MT_getIntg_PID_controller(PID_controller_s* ythis, ThCxt* _thCxt);
/* J2C:Implementation of the method, used for an immediate non-dynamic call: */
METHOD_C float getIntg_PID_controller_F(PID_controller_s* ythis, ThCxt* _thCxt);
/* J2C:Call of the method at this class level, executes a dynamic call of the override-able method: */
METHOD_C float getIntg_PID_controller(PID_controller_s* ythis, ThCxt* _thCxt);

/**Connect the Input of PID controller to a short variable.*/
typedef void MT_connectInput_PID_controller(PID_controller_s* ythis, int16_Y* valueTEST, ThCxt* _thCxt);
/* J2C:Implementation of the method, used for an immediate non-dynamic call: */
METHOD_C void connectInput_PID_controller_F(PID_controller_s* ythis, int16_Y* valueTEST, ThCxt* _thCxt);
/* J2C:Call of the method at this class level, executes a dynamic call of the override-able method: */
METHOD_C void connectInput_PID_controller(PID_controller_s* ythis, int16_Y* valueTEST, ThCxt* _thCxt);

/**provides the reference to the output for wiring to any connection.*/
typedef int16_Y* MT_provideOutput_PID_controller(PID_controller_s* ythis, ThCxt* _thCxt);
/* J2C:Implementation of the method, used for an immediate non-dynamic call: */
METHOD_C int16_Y* provideOutput_PID_controller_F(PID_controller_s* ythis, ThCxt* _thCxt);
/* J2C:Call of the method at this class level, executes a dynamic call of the override-able method: */
METHOD_C int16_Y* provideOutput_PID_controller(PID_controller_s* ythis, ThCxt* _thCxt);

/* J2C:Implementation of the method, used for an immediate non-dynamic call: */
METHOD_C void init_PID_controller_F(ObjectJc* ithis, ThCxt* _thCxt);
/* J2C:Call of the method at this class level, executes a dynamic call of the override-able method: */
METHOD_C void init_PID_controller(ObjectJc* ithis, ThCxt* _thCxt);

/* J2C:Implementation of the method, used for an immediate non-dynamic call: */
METHOD_C void parametrize_PID_controller_F(ObjectJc* ithis, ThCxt* _thCxt);
/* J2C:Call of the method at this class level, executes a dynamic call of the override-able method: */
METHOD_C void parametrize_PID_controller(ObjectJc* ithis, ThCxt* _thCxt);

/* J2C:Implementation of the method, used for an immediate non-dynamic call: */
METHOD_C void reset_PID_controller_F(ObjectJc* ithis, ThCxt* _thCxt);
/* J2C:Call of the method at this class level, executes a dynamic call of the override-able method: */
METHOD_C void reset_PID_controller(ObjectJc* ithis, ThCxt* _thCxt);

/* J2C:Implementation of the method, used for an immediate non-dynamic call: */
METHOD_C void step_i_PID_controller_F(ObjectJc* ithis, int32 time, ThCxt* _thCxt);
/* J2C:Call of the method at this class level, executes a dynamic call of the override-able method: */
METHOD_C void step_i_PID_controller(ObjectJc* ithis, int32 time, ThCxt* _thCxt);


/* J2C: Method table contains all dynamic linked (virtual) methods
 * of the class and all super classes and interfaces. */
extern const char sign_Mtbl_PID_controller[]; //marker for methodTable check
typedef struct Mtbl_PID_controller_t
{ MtblHeadJc head;
  MT_calculate_PID_controller* calculate;
  MT_setIntg_PID_controller* setIntg;
  MT_getIntg_PID_controller* getIntg;
  MT_connectInput_PID_controller* connectInput;
  MT_provideOutput_PID_controller* provideOutput;
  Mtbl_ObjectJc ObjectJc;
  //Method table of interfaces:
  Mtbl_CtrlBase CtrlBase;
} Mtbl_PID_controller;

#endif //__PosCtrl_PID_controller_h__
