#ifndef __LogMessageOld_i_h__
#define __LogMessageOld_i_h__
#include "Fwc/fw_Exception.h"
#include "OSAL/inc/os_time.h"
#include <stdarg.h>

/**Sends a message to a log system.
 * @param identNumber The identnumber idents the source and kind of message.
                      It is possible to select the destination of message output by ident numbers.
                      It is also possible to select output texts in foreign languages on output system by ident number.
                      It is possible to mark "comming" and "going" from a message, using the positiv and negativ value of the number.
                      The positiv and negativ value should present the same identNumber.
 * @param text The default, immediate output text
 * @param val1 an integer value to place in text or store
 * @param val2 an integer value to place in text or store
 * @param val3 an integer value to place in text or store
 * @param val4 an integer value to place in text or store
 */
void sendMsg_4i_LogMessageFW_i(struct LogMessageFW_t* ythis, int identNumber, const char* text, int val1, int val2, int val3, int val4, struct SthC_t* _sthC);

void sendMsg_LogMessageFW_i(struct LogMessageFW_t* ythis, int identNumber, const char* text, ...);

#endif
