echo off
call setXML_TOOLBASE.bat

REM Sets the own file as input, using env-variable INPUT for better documentation:
set INPUT=genXmi_Java2C_zmake.bat

REM calling Zmake, Translation this file via ZBNF to XML, and than to an ANT.xml-script:
echo on
%ZMAKE_EXE% ./%INPUT% -tmp=../tmp -zbnf4ant=xsl/ZmakeStd.zbnf -xslt4ant=xsl/ZmakeStd.xslp --report:../tmp/zmake_test.rpt
echo off
if errorlevel 1 goto :error

REM calling ANT
echo CLASSPATH=%CLASSPATH%
echo on
call %ANT_HOME%\bin\ant -f ..\tmp\ant_%INPUT%.xml -DcurDir=%CD%
pause
exit /B

:error 
 pause
exit /B
 

************************************************************************************************************
The own content is following now. Note that the file content from here is used not as batch file but as ZBNF input file.
Therefore after the keyword ZMAKE_RULES there is an other comment notation:

ZMAKE_RULES:

$javaInput=fileset
( AllData.java                 
, CCodeData.java               
, ClassData.java
, ConfigSrcPathPkg_ifc.java
//, CRuntimeJavalikeClassData.java               
, FieldData.java               
, FirstPass.java               
, GenerateClass.java           
, GenerateFile.java            
, iWriteContent.java           
, Java2C.java                  
, Java2C_Main.java  
, JavaSources.java
, JavaSrcTreeFile.java
, JavaSrcTreeGetter.java
, JavaSrcTreePkg.java           
, LocalIdents.java             
, Method.java
, ReadStructure.java
, RunRequiredFirstPass_ifc.java
, SecondPass.java              
);
 
../tmp/*.*.xml := zbnfJava($javaInput, srcpath="..\srcJava\org\vishia\java2C");

../tmp/Java2C.xmi := javaXML2XMI($javaInput, srcpath="../tmp", srcext=".xml");
