package org.vishia.java2C;
import java.util.List;

import org.vishia.mainCmd.Report;


/**Interface to access to getted values of a input cfg file. 
 */
public interface ConfigSrcPathPkg_ifc
{
  /**Sub-interface to get values from a prefix/postfix-set. */
  public interface Set
  { 
    /**Gets the path and maybe a file prefix. Return "" if it isn't given in input.cfg. */
    String getFilePrefix();
    /**Gets the postfix for files. Return null if it isn't given in input.cfg. Than the prefix contains the whole filename. */
    String getFileSuffix();
    /**Gets the prefix for names. Return "" if it isn't given in input.cfg. */
    String getNamePrefix();
    /**Gets the postfix for names. Return null if it isn't given in input.cfg. Than the prefix contains the whole classname*/
    String getNameSuffix();
  }
  
  /**Returns the list of all pathes parsed with 
   * <pre>
   * stcPath::=<?>{ <\"\"?stcPath>| <* :;?stcPath> ? : }.
   * </pre>
   */ 
  List<String> getStcPathes();

  /**Returns the list of all pathes parsed with 
   * <pre>
   * srcPath::=<?>{ <\"\"?srcPath>| <* :;?srcPath> ? : }.
   * </pre>
   */ 
  List<String> getSrcPathes();

  /**Returns the list of all sources to translate.
   * A member of the list is either a Java file with package from the pkg root with <code>/</code> at separator,
   * at example <code>org/vishia/util/StringPart.java</code>
   * or it is a package with <code>/</code> as separator and on end, 
   * at example <code>org/vishia/util/</code>. 
   */ 
  List<String> getSrcToTranslate();

  /**Returns the Set of path, prefix and postfix for a given package path.
   * @return If the package path isn't found, returns null.
   */
  Set getCPathPrePostfixForPackage(String javaPackagePath);
  
  void reportConfig(Report report, int reportLevel);


}
