package org.vishia.java2C.test;

public class AnyClass
{
  int x1 = 5;
  
  /**The ref is needed to test {@link #returnRefSimle(int)} for concatenations of references.
   */
  ImplIfc ref;
  
  AnyClass(ImplIfc ref)
  { this.ref = ref;
  }
  
  /**Any final method to call. */
  final int addValue(int value)
  { x1 += value;
    return x1;
  }
  
  /**Any override-able method to call. */
  int addValueOverrideable(int value)
  { x1 += value;
    return x1;
  }
  
  /**Returns itself (this)
   * @java2c=return-this.
   * @param value
   * @return
   */
  final AnyClass returnThis(int value)
  { x1 += value;
    return this;
  }
  
  /**Returns itself (this), but the method is able to override. Therefore a dynamic call should be used.
   * @java2c=return-this.
   */
  AnyClass returnThisOverrideable(int value)
  { x1 += value;
    return this;
  }
  
  /**Returns any other instance.
   * @param value
   * @return
   */
  final ImplIfc returnRef()
  { return ref;
  }

  /**Returns any other instance, but this method is able to override, non final.
   * @param value
   * @return
   */
  ImplIfc returnRefOverrideable()
  { return ref;
  }

}
