package org.vishia.java2C.test;

public interface Ifc2
{
  /**Example for an interface method with the same name but other parameter types,
   * which is implemented together with {@link Ifc#processIfcMethod(int)} in {@link ImplIfc}.
   * In Java that are two different methods of course, and also in C.
   * In both interfaces, this methods are independent, this method is declared with an method type
   * in its headerFile, adequate to the other method in Ifc:
   * <pre>
   * typedef float MT_processIfcMethod_Ifc2_Test(ObjectJc* ithis, float input, ThCxt* _thCxt);
   * </pre> 
   */
  float processIfcMethod(float input);

  /**Another method. */
  float testIfc2(float input);

  /**Example for an interface method, which has the same name and same paremeters like the method
   * {@link Ifc#anotherIfcmethod(float)}. Therefore only one implementation is necessary. 
   * In this interface the method type
   * <pre>
   * METHOD_C float anotherIfcmethod_Ifc2_Test(ObjectJc* ithis, float input, ThCxt* _thCxt);
   * </pre>
   * is declared for it. In opposite the method type of the same method {@link Ifc#anotherIfcmethod(float)} is
   * <pre>
   * METHOD_C float anotherIfcmethod_f_Ifc_Test(ObjectJc* ithis, float input, ThCxt* _thCxt);
   * </pre>
   * Both declarations are independent, because the interface definitions are so. But the implementation
   * for both methods are the same, and the implementation are compatible to both declarations of function type.
   * See {@link ImplIfc#anotherIfcmethod(float)}.
   */
  float anotherIfcmethod(float input);
  
  
}
