package org.vishia.java2C.test;


/**This is an example for a simple class without interface, but override-able methods.
 * It based on ObjectJc, because the overriding of methods needs this base class.
 * The <code>struct</code> in C is defined in the following form:
 * <pre>
typedef struct SimpleClass_Test_t
{ 
  union { ObjectJc object; } base; 
  int32 x1;
} SimpleClass_Test_s;
 * </pre>
 * It contains the base data of <code>ObjectJc</code> wrapped with the <code>union</code>,
 * because the access to the <code>ObjectJc</code> is written anyway in form <code>ref.base.object</code>.
 * The <code>struct</code> contains the data. 
 * <br><br>
 * There are two additional defines for all classes in C:
 * <pre>
typedef struct SimpleClass_Test_Y_t { ObjectArrayJc head; SimpleClass_Test_s data[50]; } SimpleClass_Test_Y;

extern struct ClassJc_t const reflection_SimpleClass_Test_s;
 * </pre>
 * <ul>
 * <li>The first line defines a array structure. It is ready to use always. The number of data is a placeholder.
 * The structure type is used as a reference anytime. Than the really number of elements in the array
 * depends from the memory allocation size and it is stored in the head data.  
 * <li>The second line declares the existence of reflection for the class in C.
 * </ul>
 * Methods are defined as prototypes in headerfile:
 * <pre>
METHOD_C struct SimpleClass_Test_t* ctorO_SimpleClass_Test(ObjectJc* othis, ThCxt* _thCxt);

typedef int32 MT_addValue_SimpleClass_Test(SimpleClass_Test_s* ythis, int32 value, ThCxt* _thCxt);

METHOD_C int32 addValue_SimpleClass_Test_F(SimpleClass_Test_s* ythis, int32 value, ThCxt* _thCxt);

METHOD_C int32 addValue_SimpleClass_Test(SimpleClass_Test_s* ythis, int32 value, ThCxt* _thCxt);
 * </pre>
 * <ul>
 * <li>The first line is the constructor definition, auto generated.
 * <li>The second line is the method type definition as a so named <i>C-function pointer type</i>.
 *   It is used in the method table.
 * <li>The third line declares the final version of the method, 
 *   whereas the forth line declares that method definition, which executes a dynamic linked call.
 * </ul>
 * The header file contains at last the method table type definition:
 * <pre>
extern const char sign_Mtbl_SimpleClass_Test[]; //marker for methodTable check
typedef struct Mtbl_SimpleClass_Test_t
{ MtblHeadJc head;
  MT_addValue_SimpleClass_Test* addValue;
  Mtbl_ObjectJc ObjectJc;
} Mtbl_SimpleClass_Test;
 * </pre>
 * See {@link org.vishia.java2C.Docu.D_SuperClassesAndInterfaces#D8_gen_MethodTable()}.  
 */
public class SimpleClass
{

  int x1 = 5;
  
  int addValue(int value)
  { x1 += value;
    return x1;
  }
  
  
}
