package org.vishia.java2C.test;



/**It is not a final (able to expand)  
 * data class. It doesn't base on ObjectJc in C. 
 * In C the <code>struct</code> is defined as:
 * <pre>
typedef struct ExpandableDataStruct_Test_t
{ 
  int16 xb;
  int16 yb;
  double db;
} ExpandableDataStruct_Test_s;
 *</pre>
 * It is very simple. Such an class may be used in an array. 
 * The inheritance from Object is a basic feature in Java anytime, but this feature doesn't may be used mostly.
 * Therefore in C it can be optimized writing a <code>@ java2c=noObject.</code>-tag in the comment.
 * <br><br>
 * See also {@link ExpandedDataStruct}. Inherited classes don't base on Object too.
 *  
 * @java2c=noObject.
 */
public class SimpleDataStruct
{
  /**Some variables in the data class. <code>short</code>in Java will be translated to <code>int16</code> in C. */
  short xb,yb;
 
  /**A double variable in Java is a double variable in C too. (8 Byte float).
   */
  double db;
}

