package org.vishia.util;

public class ThreadContext
{ 
  /**The thread-specific ThreadContext. This element is existing once per Thread. */
  private static ThreadLocal<ThreadContext> currentThreadContext =
    new ThreadLocal<ThreadContext>() 
    { //implicit class:
      @Override protected ThreadContext initialValue() 
      { return new ThreadContext();
      }
    };
  
    
  /**String Buffer to store a thread local exception message for throw operations.
   * Using this variable no new operation is needed on throw statement.
   * But on using first the exsMsg should be clerad.<br>
   * Example:<pre>
   * ThreadContext threadContext = ThreadContext.getCurrent();
   * threadContext->excMsg.setLength(0);
   * threadContext->excMsg.append("The message text");
   * throw new RuntimeException(threadContext->excMsg);
   */
  public StringBuffer excMsg = new StringBuffer(240);  
    
    
    
  public ThreadContext()
  { 
  }
    
  public static ThreadContext getCurrent()
  {
    return currentThreadContext.get();
  }
  
  
}
